{% extends 'dashboard/dashboard_content.html' %}

{% block head_block %}
    <script type="text/javascript">

        var absentees_list = [];
        var od_list = [];

        function remove(arr, item) {
            //alert(arr.length);
            for (var i = arr.length; i--;) {
                if (arr[i] == item) {
                    //alert('matched')
                    arr.splice(i, 1);
                }
            }
        }
        $('document').ready(function () {

            $('[name="present"]').change(function () {
                present_id = $(this).attr('id');
                onduty_id = present_id.replace('ab', 'od');
                if (this.checked) {
                    $('#' + onduty_id).removeAttr('checked');
                }
            });

            $('[name="onduty"]').change(function () {
                onduty_id = $(this).attr('id');
                present_id = onduty_id.replace('od', 'ab');
                if (this.checked) {
                    $('#' + present_id).removeAttr('checked');
                }
            });


            $("#submit_form").click(function () {

                for (var i = 0, l = absentees_list.length; i < l; i++) {
                    var value = absentees_list[i];
                    var $hiddenInput = $('<input/>', {type: 'hidden', value: value, name: 'absent'});
                    $hiddenInput.appendTo('form');
                }
                $('#attendance_form').submit();
            });
            $("#absent_prompt").on('show.bs.modal', function () {
                var myNode = document.getElementById("entry");
                while (myNode.firstChild) {
                    myNode.removeChild(myNode.firstChild);
                }
                absentees_list = []
                od_list = []
                $("input:checkbox[name=present]").each(function () {
                    //alert("Id: " + $(this).attr("id") + " Value: " + $(this).val() + " Checked: " + $(this).is(":checked"));
                    if ($(this).is(":checked") != true) {
                        absentees_list.push($(this).val());
                    }
                });
                $("input:checkbox[name=onduty]").each(function () {
                    //alert("Id: " + $(this).attr("id") + " Value: " + $(this).val() + " Checked: " + $(this).is(":checked"));
                    if ($(this).is(":checked") == true) {
                        od_list.push($(this).val());
                        remove(absentees_list, $(this).val());
                    }
                });
                var myNode = document.getElementById("id_absent_count");
                if (myNode.firstChild) {
                    myNode.removeChild(myNode.firstChild);
                }
                $("#id_absent_count").append(absentees_list.length);
                var myNode = document.getElementById("id_onduty_count");
                if (myNode.firstChild) {
                    myNode.removeChild(myNode.firstChild);
                }
                $("#id_onduty_count").append(od_list.length);
                if (absentees_list.length == 0) {
                    $("#entry").append('<tr class="text-centerd"><td class="text-centerd">None</td></tr>');
                }
                for (var i = 0, l = absentees_list.length; i < l; i++) {
                    $("#entry").append('<tr class="text-centerd"><td class="text-centerd">' + absentees_list[i] + '</td></tr>');
                }

                var myNode = document.getElementById("od_entry");
                while (myNode.firstChild) {
                    myNode.removeChild(myNode.firstChild);
                }
                if (od_list.length == 0) {
                    $("#od_entry").append('<tr class="text-centerd"><td class="text-centerd">None</td></tr>');
                }
                for (var i = 0, l = od_list.length; i < l; i++) {
                    $("#od_entry").append('<tr class="text-centerd"><td class="text-centerd">' + od_list[i] + '</td></tr>');
                }
            });

            $("#id_select_all_present").change(function() {

                if (this.checked) {
                console.log(this.checked);
                    $('[name="present"]').prop("checked",true);
                    $('[name="onduty"]').prop("checked",false);
                    $("#id_select_all_onduty").prop("checked",false);
                } else {
                    $('[name="present"]').removeAttr('checked');
                }
            });
            $("#id_select_all_onduty").change(function() {

                if (this.checked) {
                console.log(this.checked);
                    $('[name="onduty"]').prop("checked",true);
                    $('[name="present"]').prop("checked",false);
                    $("#id_select_all_present").prop("checked",false);
                } else {
                    $('[name="onduty"]').removeAttr('checked');
                }
            });
        });
    </script>
    <script>
        $('document').ready(function () {
            $('#batch_split_form').change(function() {
                console.log('submit form');
                $('#batch_split_form').submit();
            });
        });
    </script>
    <script>
        $('document').ready(function () {
            $('[name="student_delete"]').click(function() {
                console.log('delete called');
                $(this).parent().parent().remove();
            });
        });
    </script>
{% endblock %}

{% block rightPane %}
    <div class="x_panel">
        <div class="x_title">
            <h2 style="word-wrap: break-word">
                <i class="fa fa-calendar-check-o"></i>
                Mark Attendance
            </h2>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <div class="col-md-10 col-md-offset-1">
                 <div class="alert alert-success text-center" role="alert">
                     <h4>
                    <strong>
                        You are going to mark attendance for course {{ course_id }}, for the date {{ attendance_date }}, hour : {{ hour }}
                    </strong>
                         </h4>
                 </div>
                {% if batch_split_instances %}
                <div class="pull-right">
                    <form method="post" id="batch_split_form" name="batch_split_form" class="form-inline">{% csrf_token %}
                        <label for="id_batch_split_pk" class="control-label">Select Batch</label>
                        <select id="id_batch_split_pk" name="batch_split_pk" class="form-control">
                            {% for batch_split_instance in batch_split_instances %}
                                {% if batch_split_instance.pk == selected_batch_split.pk %}
                                    <option value={{ batch_split_instance.pk }} selected>Batch - {{ batch_split_instance.batch_number }}</option>
                                {% else %}
                                    <option value={{ batch_split_instance.pk }} >Batch - {{ batch_split_instance.batch_number }}</option>
                                {% endif %}
                            {% endfor %}
                        </select>

                    </form>
                </div>
                {% endif %}
                <form method="POST" id="attendance_form" name="attendance_form">{% csrf_token %}
                    <table class="table text-center">
                        <thead>
                        <tr>
                            <th style="text-align: center">S.No.</th>
                            <th style="text-align: center">Student Name</th>
                            <th style="text-align: center">Register Number</th>
                            <th>
                                Present<br>
                                    <input type="checkbox" id="id_select_all_present" checked="checked"> Select all

                            </th>
                            <th>On-duty<br>
                                    <input type="checkbox" id="id_select_all_onduty"> Select all
                            </th>
                        </tr>
                        </thead>
                        <tbody>
                        {% for student in student_list %}
                            <tr {% if student.granted_od %}class="alert-success" {% endif %}>
                                <td>{{ forloop.counter }}</td>
                                <td>{{ student.student_name }}</td>
                                <td>{{ student.registration_number }}</td>
                                <td style="align-items: inherit"><input type="checkbox" name="present"
                                                                        value={{ student.registration_number }} {% if not student.already_absent and not student.granted_od %}checked{% endif %}
                                                                        id="ab_{{ forloop.counter }}" class="checkbox"/>
                                </td>
                                <td style="text-align: center"><input type="checkbox" name="onduty"
                                                                      value={{ student.registration_number }} {% if student.granted_od %}checked{% endif %}
                                                                      id="od_{{ forloop.counter }}" class="checkbox"/>
                                </td>
                                <td>
                                    <button type="button" class="btn btn-sm btn-danger" name="student_delete">
                                      <span class="fa fa-close"></span> Remove
                                    </button>
                                </td>

                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                    <div class="text-center">
                        <button type="button" class="btn btn-primary btn-lg" data-toggle="modal"
                                data-target="#absent_prompt"
                                id='attendance_submit_buttom'>
                            Submit Attendance
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <div id="absent_prompt" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                    <h4 class="modal-title">Attendance Result</h4>
                </div>
                <div class="modal-body">
                    <div class="col-md-8 col-md-offset-2">
                        <table class="table table-bordered">
                            <thead>
                            <th>Absent students ( <div id="id_absent_count" style="display:inline"></div> )</th>
                            </thead>
                            <tbody id='entry'>

                            </tbody>
                        </table>
                        <table class="table table-bordered">
                            <thead>
                            <th>Onduty students ( <div id="id_onduty_count" style="display:inline"></div> )</th>
                            </thead>
                            <tbody id='od_entry'>

                            </tbody>
                        </table>
                    </div>

                </div>
                <div class="clearfix"></div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-lg btn-primary" data-dismiss="modal" id="submit_form">Confirm
                        Submission
                    </button>
                </div>
            </div>
        </div>
    </div>

{% endblock %}